#include <stdio.h>
#include <string.h>
#include <stdlib.h>

unsigned char* buf;

int main(int argc, char *argv[]) 
{
    
    if (argc != 2)
    {
      printf("mml_fix -> correct tinymm's octave raisers/lowerers\n"
             "Usage: mml_fix <mml_file>\n");
      getch();             
      return -1;
    }
    
    char ch;
    int size, i = 0;
    
    FILE *mml = fopen(argv[1], "r+b");
    
    if (mml == NULL)
    {
      printf ("Error opening .mml file.\n");
      getch();             
      return -1;      
    }

    fseek (mml , 0 , SEEK_END);
    size = ftell (mml);
    rewind(mml);
    
    buf = (char*)malloc(sizeof(char)*size);
    fread(buf, 1, size,  mml);
    
    fclose(mml);
    
    for (i = 0; i < size; i++)
    {    
        switch (buf[i])
        {
            case '>':
                buf[i] = '<';
                break;
            case '<':
                buf[i] = '>';
                break;
            default:
                break;
       }
    }     
    
    
    char * filename = malloc( strlen(argv[1]) + 4 );
    
    strcpy( filename, argv[1] );
    strcat( filename, ".mml" );
    
    FILE *out = fopen(filename, "wb");      
    
    for (i = 0; i < size; i++)
    {     
      fputc(buf[i], out);      
    }    
      
    printf("Corrected .mml saved as %s.\n", filename);
    
    fclose(out);
    free(buf);
    
    getch();
    
            
  	return 0;
}
